//+------------------------------------------------------------------+
//|                           Copyright 2005,  bobammax              |
//| Some new features were added                                     |
//| by newdigital from http://www.forex-tsd.com/forum.php            |
//| - working hours selection.                                       |
//|   EA will process any opened orders within working hours         |
//|   but will not open new one;                                     |
//| - Period of trading should be selected now                       |
//|   (PeriodTrading = 240 is H4);                                   |
//| - Ichimoku setting may be selected                               |
//|   (Tenkan_sen, Kijun_sen and Senkou_Span_B).                     |
//|   Classical settings is 9, 26 and 52.                            |
//|   Other possible settings are the following:                     |
//|   M5 72-144-288; H1 12-24-120 or 120-240-480;                    |
//|   D1 5-10-20 or 9-26-52; W1 9-26-52; etc.                        |
//| http://www.forex-tsd.com/forum.php                               |
//+------------------------------------------------------------------+

#property copyright "Copyright  2011, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

//
//
//
//
//

extern int    MAGIC          = 878787;
extern string Name_Expert    = "nonlagdot+qqe";
extern bool   EcnBroker      = false;
extern double lStopLoss      = 37;
extern double sStopLoss      = 35;
extern double lTakeProfit    = 80;
extern double sTakeProfit    = 75;
extern double lTrailingStop  = 20;
extern double sTrailingStop  = 20;
extern int    Slippage       = 4;
extern double Lots           = 0.1;
extern double MaximumRisk    = 0;
extern double DecreaseFactor = 3;

extern int    nonlagTf       = 0; 
extern int    Price          = 0;
extern int    Length         = 20;
extern int    Displace       = 0;
extern int    Filter         = 0;
extern int    Color          = 1;
extern int    ColorBarBack   = 0;
extern double Deviation      = 0; 
extern int    qqeTf          = 0; 
extern int    SF             = 5; 
extern int    RSI_Period     = 14; 
extern double DARFACTOR      = 4.236;      
extern int    bar            = 1;


extern bool   UseHourTrade   = true;
extern int    FromHourTrade  = 8;
extern int    ToHourTrade    = 19;

extern color  clOpenBuy      = Blue;
extern color  clCloseBuy     = Aqua;
extern color  clOpenSell     = Red;
extern color  clCloseSell    = Violet;
extern color  clModiBuy      = Blue;
extern color  clModiSell     = Red;

//
//
//
//
//

double pipMultiplier = 1;

//
//
//
//
//

int init() {  return(0); }

//
//
//
//
//

int deinit() { Comment(""); return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   if (Digits == 3 || Digits == 5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;  
   
   //
   //
   //
   //
   //
   
   if(Bars < 100) { Print("bars less than 100"); return(0); }
   
   //
   //
   //
   //
   //
   
   if (UseHourTrade)
   {
     if(!(Hour() >= FromHourTrade && Hour() <= ToHourTrade)) { Comment("Non-Trading Hours!");  return(0);  }
   }
   
   //
   //
   //
   //
   //
   
   if(lStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if(lTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   if(sStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if(sTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   
   //
   //
   //
   //
   //
   
   double nltrend   = iCustom(NULL,nonlagTf,"nonlagdot",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,4,bar);
   double diCustom1 = iCustom(NULL,qqeTf,"QQE",SF,RSI_Period,DARFACTOR,0,bar);
   double diCustom2 = iCustom(NULL,qqeTf,"QQE",SF,RSI_Period,DARFACTOR,1,bar);
   double diCustom3 = iCustom(NULL,qqeTf,"QQE",SF,RSI_Period,DARFACTOR,0,bar+1);
   double diCustom4 = iCustom(NULL,qqeTf,"QQE",SF,RSI_Period,DARFACTOR,1,bar+1);

   
   if (!ExistPositions())
   {

      if (nltrend > 0 && diCustom1 > diCustom2 && diCustom3 <= diCustom4)
      {
         OpenBuy();
         return(0);
      }

      if (nltrend < 0 && diCustom1 < diCustom2 && diCustom3 >= diCustom4)
      {
         OpenSell();
         return(0);
      }
   }
   TrailingPositionsBuy(lTrailingStop);
   TrailingPositionsSell(sTrailingStop);
   return (0);
}

//
//
//
//
//

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC) {
				return(True);
			}
		} 
	} 
	return(false);
}

//
//
//
//
//

void TrailingPositionsBuy(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
               if (Bid-OrderOpenPrice() > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() < Bid-trailingStop * Point * pipMultiplier) 
                     ModifyStopLoss(Bid - trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() > Ask + trailingStop * Point * pipMultiplier || OrderStopLoss() == 0)  
                     ModifyStopLoss(Ask + trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
  
} 

//
//
//
//
//

void OpenBuy() 
{ 
    
   double ldStop = GetStopLossBuy(); 
   double ldTake = GetTakeProfitBuy(); 
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage,ldStop,ldTake,Name_Expert,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket = OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage * Point * pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket >= 0)
         OrderModify(buyTicket,OrderOpenPrice(),ldStop,ldTake,0,CLR_NONE);
   }		       
   

}

//
//
//
//
//

void OpenSell() 
{ 

   double ldStop = GetStopLossSell(); 
   double ldTake = GetTakeProfitSell(); 
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage,ldStop,ldTake,Name_Expert,MAGIC,0,clOpenSell); 
   else
   {
         int sellTicket = OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage * Point * pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenSell);		    		    
         if (sellTicket >= 0)
         OrderModify(sellTicket,OrderOpenPrice(),ldStop,ldTake,0,CLR_NONE);
   }		       
   

} 

//
//
//
//
//

double GetStopLossBuy()    { 	return(Bid - lStopLoss   * Point * pipMultiplier); } 
double GetStopLossSell()   { 	return(Ask + sStopLoss   * Point * pipMultiplier); } 
double GetTakeProfitBuy()  { 	return(Ask + lTakeProfit * Point * pipMultiplier); } 
double GetTakeProfitSell() { 	return(Bid - sTakeProfit * Point * pipMultiplier); } 

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max  = MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step = MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract = MarketInfo(Symbol(),MODE_LOTSIZE);
   double lot = Lots;
   int    orders = HistoryTotal();     // history orders total
   int    losses = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit()>0) break;
      if(OrderProfit()<0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
   
   //
   //
   //
   //
   //
   
   return(lot);
} 

//
//
//
//
//



